*+
*+
*+    Source Module => D:\INCOMING\TEMP\PSTRU.PRG
*+
*+    Functions: Procedure PrintSTRU()
*+               Function rsvprompt()
*+               Function strip()
*+
*+       Tables: use pstru NEW
*+               use
*+
*+    Reformatted by Click! 1.13 on Mar-29-1998 at  9:28 pm
*+
*+

/************************************************************************
  program......: pstru.prg
  prgmr........: cl carter
  date.........: 12-22-93 09:23am
  purpose......: print a dbf structure from the menu
  parmameters..: none
  output.......: listing of field names, types, and lengths, and position
                 numbers that will come in handy for flat file (.SDF)
                 import/export formats.

                fld  name      type len   dec  POSITION
                  1  cChar1    c      1     0         1
                  2  nNum1     n      5     2         2
                  3  dDate     d      8     0         7
                  3  cChar3    c     10     0        13

output goes to file STRU.TXT, LPT1 or {name}.TXT where {name} is
the .DBF file name, according to the user's choice.

************************************************************************/

#include "inkey.ch"

*+
*+
*+    Procedure PrintSTRU()
*+
*+
*+
procedure PrintSTRU()

local nLine
local nTtl
local i
local lToFile := .t.
local cOut
local cDBF    := alias()
local nBytes  := 0

cOut := rsvprompt( "Print to <L>pt1 <S>tru.txt or " + cDBF + ".<T>xt", "LST" )

if cOut $ "LST"

   COPY STRU EXTENDED to "pstru"

   use pstru NEW

   if !neterr()

      do case

      case cOut == "S"
         cFile := "STRU.TXT"
      case cOut == "T"
         cFile := cDBF + ".TXT"
      case cOut == "L"
         cFile   := "LPT1"
         lToFile := .f.

      otherwise
         return "Not Printed."

      endcase

      // print append if going to STRU.TXT
      if cFile == "STRU.TXT"
         set printer to &cFile additive
      else
         set printer to &cFile
      endif

      set device to printer
      go top

      // force a page heading
      nLine := 200
      nTtl  := 0
      do while !eof()
         if nLine >= 58
            nLine := 1
            @ nLine,  1 say upper( cDBF + '.dbf' )         
            nLine += 2
            for i := 1 to fcount()
               // get rest of FIELD_{item} starting after "_"
               @ nLine,  6 + ( I - 1 ) * 12 say substr( field( i ), rat( "_", field( i ) ) + 1 )         
            next i
            @ nLine, pcol() + 7 say "POSITION"         
            nLine ++
         endif

         @ nLine,  1 say recno() pict '999'        
         for i := 1 to fcount()
            @ nLine,  6 + ( i - 1 ) * 12 say fieldget( i )         
         next i

         // translate date fields, always use 10 if so
         nBytes := iif( fieldget( 2 ) == "D", 10, fieldget( 3 ) )

         // start pos is last total + 1
         @ nLine,  6 + ( i - 1 ) * 12 say nTtl + 1 pict "99,999"        

         nTtl += nBytes                 // now accum total for next start pos
         nLine ++   // bump line counter
         skip

      enddo
      @ ++ nLine, 5 say 'Total Bytes:'                      
      @ nLine, 25   say nTtl           pict '99,999'        
      set device to screen
      use
      return "Printed to " + cFile
   else
      return "Network Error!"
   endif
else
   return "Not Printed."
endif

/*
 rsvprompt( cPrompt, cValid )

 stolen from dbuutil.prg function rsvp

 cl carter

 prompts user for message cPrompt
  waits for keypress of character in cValid and
  returns keypress, or empty string if user hits <ESC>

*/

*+
*+
*+    Function rsvprompt()
*+
*+    Called from ( pstru.prg    )   1 - procedure printstru()
*+
*+
*+
function rsvprompt( cPr, cVal )

local cPrompt := ""
local cValid  := ""
local cRtn    := ""
local cAns    := " "

// parameter check
if valtype( cPr ) == "C"
   cPrompt := cPr
endif

if valtype( cVal ) == "C"
   cValid := cVal
endif

if ( len( cPrompt ) > 0 ) .and. ( len( cValid ) > 0 )

   // {char in cValid}/Esc
   do while !( cAns $ cValid + chr( K_ESC ) )

      // display message bright like error message
      error_msg( cPrompt + " " )

      // place the cursor at the end of the message
      @  3, len( cPrompt ) + 2 say ""         

      // make the cursor visible
      set cursor on

      // get the response and erase the message
      cAns := upper( chr( raw_key() ) )

      // if not esc, save return
      if asc( cAns ) != K_ESC
         cRtn := cAns
      endif

      if !M->curs_on
         // get rid of the cursor
         set cursor OFF

      endif

   enddo

endif

return cRtn

/*****************************************************************
 function..: strip
 author....: c l carter
 date......: 12-27-96 09:02pm
 purpose...: remove characters from parm cStr that are not
             numeric or a decimal.

 cStrip( "(540)-555-1212" ) => "5405551212"
 cStrip( '45" LADLE PRESS' => "45"

 update:
 cStrip( "540.555.1212" ) => "540.555.1212"
 Whomever started giving out phone numbers like web addresses
 needs to understand that the phone system as not the web.

******************************************************************/

*+
*+
*+    Function strip()
*+
*+
*+
function strip( cStr )

local cRtn := ''
local i
local cCh

if valtype( cStr ) = 'C'
   for i := 1 to len( cStr )
      cCh := substr( cStr, i, 1 )
      if cCh $ "0123456789."
         cRtn += cCh
      endif
   next
endif

return cRtn

// eof: pstru.prg

*+ EOF: PSTRU.PRG
